 '-----------------------------------------------------------------------------------------
'name                     : lcd_m8515_v_1_5_ons.bas
'copyright                : (c) danzup
'purpose                  : Preamp controller
'micro                    : AtMega85105
'version                  : 1.5.ons
' this version with 6input, RC5 remote control & motorized alps volume potentiometer ,
' backlight LED  control     ,
' mute is activ from remote an printed on LCD  ,comanda lina potentiometru alps
'-----------------------------------------------------------------------------------------
$regfile = "m8515.dat"                                      ' specify the used micro
$crystal = 8000000                                          ' used crystal frequency
Ddrd = &B11000000                                           ' PD6...PD7 are output, PD0...PD5 are input
Portd = &B00111111                                          ' PD0...PD5 pull-up resistor enable
Ddra = &B11111111                                           ' PA0...PA7 are output ,input relay control
Ddrb = &B11111111                                           ' PB0...PB7 are output , volume motor control
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0
Config Porta = Output
Config Portb = Output
Dim Address As Byte , Command As Byte                       'RC5 ir variable
Dim A As Bit                                                'first button
Dim B As Bit                                                'second button
Dim C As Bit                                                'third button
Dim W As Word
Dim Inp_sel As Byte
Dim Pwr As Bit
Dim Mut As Bit
Declare Sub Shiftlf                                         'name say all for subroutine ...doh!!
Declare Sub Shiftrt
Declare Sub Volup
Declare Sub Voldn
Declare Sub Poweron
Declare Sub Poweroff
Declare Sub Af_sel
Declare Sub Pwr_onof
Declare Sub Mute
Declare Sub Pwr_oo
Cursor Off
Config Lcd = 16 * 2                                         'other options are 16 * 4 and 20 * 4, 20 * 2 , 16 * 1a
Config Rc5 = Pind.3                                         'pin where is conected ir senzor
Config Timer1 = Timer , Prescale = 1024
Stop Timer1
Set Portd.7                                                 'backlight on
Portb = &B11111111                                          ' PORTB.0 and PORTB.1 motor control lines for alps pot
Pwr = 0                                                     '0 =stand-by ; 1 = power on
Mut = 1                                                     ' 0 =mute , 1 = normal
Inp_sel = &B00000001                                        'default selected first input
Cls                                                         'clear the LCD display
Porta = Inp_sel                                             ' will set the input  selected default
Lcd "Preamp controler"                                      'display this at the top line
Lowerline                                                   'select the lower line
Lcd "v=1.5.ons(c)danzup"                                    'display this at the lower line
Wait 1
Cls
Enable Interrupts
 '--------------------------------------------------------------------------
If Pwr = 0 Then
Call Poweroff
End If
'--------------------------------------------------------------------------
Start Timer1
Do

If Pwr = 1 Then
   W = Timer1
 If W => 29800 Then
  Reset Portd.7                                             'will set the Port D bit 7 to 0V backlight off
 End If
 If W => 800 Then
  Set Portb.0
  Set Portb.1
 End If
 If Mut = 1 Then
  If W => 4800 Then
   Lowerline
   Lcd "                 "
  End If
 End If
 Getrc5(address , Command)                                  'read if we have remote ir command
  If Address = 8 Then
     Command = Command And &B01111111
  End If
 Select Case Command
 '---- this codes are for my remote , change code to your suit ! ----------------
   Case 32 : Call Shiftlf                                   'remote command code for CH up
   Case 33 : Call Shiftrt                                   'remote command code for CH down
   Case 16 : Call Volup                                     'remote command code for Vol +
   Case 17 : Call Voldn                                     'remote command code for Vol -
   Case 13 : Call Mute                                      'remote command code for Mute
   Case 12 : Call Pwr_onof                                  'remote command code for On/Off
 End Select
 A = Pind.0                                                 'if Pind.0 = 0 then we shift input_source left
 B = Pind.4                                                 'if Pind.4 = 0 then we shift input_source right
 C = Pind.2

   If A = 0 Then                                            'now we read the push buttons for command
      Waitms 5
      Call Shiftlf                                          'button for left selection presed
   End If
   If B = 0 Then
      Waitms 5
      Call Shiftrt                                          'button for right selection presed
   End If
   If C = 0 Then
      Waitms 5
      Call Pwr_oo
   End If
End If

If Pwr = 0 Then
 C = Pind.2
 Getrc5(address , Command)                                  'read if we have remote ir command
  If Address = 8 Then
     Command = Command And &B01111111
  End If
 Select Case Command
 '---- this codes are for my remote , change code to your suit ! ----------------
   Case 12 : Call Pwr_onof                                  'remote command code for On/Off
 End Select
 If C = 0 Then
      Waitms 5
      Call Pwr_oo
 End If
End If

Loop

End
'-----------Pwr_oo----------------
Sub Pwr_oo:
   Pwr = Not Pwr
   If Pwr = 1 Then
      Call Poweron
   Else
      Call Poweroff
   End If
End Sub
'-----------Pwr_onof-----------------
Sub Pwr_onof:
   Pwr = Not Pwr
   If Pwr = 1 Then
      Call Poweron
   Else
      Call Poweroff
   End If
End Sub
'------Poweron------------------------
Sub Poweron:
Set Portd.6                                                 'will set  power relay on
Set Portd.7                                                 'will set the Port D bit 7 to +5V backlight on
Display On                                                  'turn display on
Cls
Lcd " Power On !    "
Cls
Porta = Inp_sel
Call Af_sel
Home Lowerline
Lcd "               "
Waitms 500
End Sub
'-------Poweroff----------------------
Sub Poweroff:
Reset Portd.6                                               'will set  power relay off
Reset Portd.7                                               'will set the Port D bit 7 to 0V backlight off
Display Off                                                 'turn display off
Porta = &B00000000                                          ' mute
Waitms 500
End Sub
'---------shift input Left----------
Sub Shiftlf:
Set Portd.7                                                 'will set the Port D bit 7 to +5V backlight on
W = 0
Timer1 = W
If Inp_sel >= 1 And Inp_sel < 32 Then
Rotate Inp_sel , Left
End If
Porta = Inp_sel
Call Af_sel
Waitms 500
End Sub
'--------shift input right----------
Sub Shiftrt:
Set Portd.7                                                 'will set the Port D bit 7 to +5V backlight on
W = 0
Timer1 = W
If Inp_sel >= 2 And Inp_sel < 33 Then
Rotate Inp_sel , Right
End If
Porta = Inp_sel
Call Af_sel
Waitms 500
End Sub
'-------bring volume up-------------
Sub Volup:
Lowerline
Lcd "                "
Set Portd.7                                                 'will set the Port D bit 7 to +5V backlight on
W = 0
Timer1 = W
Reset Portb.0
Lowerline
Lcd "Volume UP !     "
Waitms 20

End Sub
'--------bring volume down----------
Sub Voldn:
Lowerline
Lcd "               "
Set Portd.7                                                 'will set the Port D bit 7 to +5V backlight on
W = 0
Timer1 = W
Reset Portb.1
Lowerline
Lcd "Volume Down !  "
Waitms 20

End Sub
'------Af_sel---------------------------
Sub Af_sel:
Home Upper
If Inp_sel = 1 Then
Lcd "DVD     selected"
End If
If Inp_sel = 2 Then
Lcd "CD      selected"
End If
If Inp_sel = 4 Then
Lcd "Tuner   selected"
End If
If Inp_sel = 8 Then
Lcd "Tape    selected"
End If
If Inp_sel = 16 Then
Lcd "Aux1    selected"
End If
If Inp_sel = 32 Then
Lcd "Aux2    selected"
End If
End Sub
'------- Mute ----------
Sub Mute:
   Mut = Not Mut
   If Mut = 1 Then
      Porta = Inp_sel
      Lowerline
      Lcd "            "
     Waitms 500
   Else
      Porta = &B00000000
      Lowerline
      Lcd "MUTE      ! "
     Waitms 500
   End If
End Sub